﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Phone.Controls;

using Microsoft.Phone.Controls.Maps; // 이걸 추가해줘야한다.
using System.Device.Location; // 이걸 추가해줘야한다.



namespace GoogleMap
{
    public partial class MainPage : PhoneApplicationPage
    {
        private GeoCoordinate mapCenter;


       double SharedInformationMyLongitude;
       double SharedInformationMyLatitude;

 
       

        GeoCoordinateWatcher watcher = null; // gps를 작동시키는 클래스 


        // Constructor
        public MainPage()
        {
            InitializeComponent();

            watcher = new GeoCoordinateWatcher(GeoPositionAccuracy.High);
            watcher.MovementThreshold = 20; // 20미터 단위로 인식한다. ㅋ 20미터 단위로 동작을 인식 20 미터 내에는 변동아 아닌걸로 인식

            // 이벤트 추가 
            watcher.StatusChanged += // 탭두번
                        new EventHandler<GeoPositionStatusChangedEventArgs>
                        (watcher_StatusChanged);
            watcher.PositionChanged += // 위치값이 바뀔때마다 값이 입력 
                        new EventHandler<GeoPositionChangedEventArgs<GeoCoordinate>>
                        (watcher_PositionChanged);

            // 데이터 가져오기 시작
            watcher.Start();

            map1.ZoomLevel = 15; // 확대 축소 
            //map1.Mode = new RoadMode();    // new AerialMode(); // 한개는 위성, 하나는 항공사진 으로 
            //map1.ZoomBarVisibility = Visibility.Visible; // 줌바를 보이는지 안보이는지 
            map1.Center = new GeoCoordinate(35.06, 129.03); // 위도,경도 지도의 정중앙 값 을 기본값으로 
            
        }

        void watcher_PositionChanged(object sender,
                          GeoPositionChangedEventArgs<GeoCoordinate> e) // 
        {
            double dbLatitude = e.Position.Location.Latitude;  // 위도
            double dbLongitude = e.Position.Location.Longitude; // 경도

            map1.Center = new GeoCoordinate(dbLatitude, dbLongitude); // 지도의 정중앙에 위도와 경도의 값을 표시 위치가 바뀔때마다 지도가 움직인다. 중아이 바뀌므로
           String strLatitude =  dbLatitude.ToString("0.00000");
           String strLongitude =  dbLongitude.ToString("0.00000");

          //  PageTitle.Text = strLatitude;// + " / " + strLongitude;
            textBlock1.Text = strLatitude;
            textBlock2.Text = strLongitude;
        }


      

        void watcher_StatusChanged(object sender,
                           GeoPositionStatusChangedEventArgs e)
        {
            String strMsg = ""; // 처음 실행할때 기계가 gps가 미지원하거나. 등등 상황을 표시
            switch (e.Status)
            {
                case GeoPositionStatus.Disabled: strMsg = "GPS미지원";
                    break;
                case GeoPositionStatus.Initializing: strMsg = "GPS초기화중";
                    break;
                case GeoPositionStatus.NoData: strMsg = "GPS작동중-데이터X";
                    break;
                case GeoPositionStatus.Ready: strMsg = "GPS작동중";
                    break;
            }

            ApplicationTitle.Text = strMsg;
        }



        private void ZoomIn_Click(object sender, EventArgs e)
        {
            map1.ZoomLevel++;
        }

        private void ZoomOut_Click(object sender, EventArgs e)
        {
            map1.ZoomLevel--;
        }

        private void ApplicationBarIconButton_Click_2(object sender, EventArgs e)
        {          

            double longitude;
            double latitude;

               //System.Diagnostics.Debug.WriteLine(textBlock1.Text);
                  longitude = double.Parse(textBlock1.Text);// (textBlock1.Text.ToString());
                  latitude = double.Parse(textBlock2.Text);
                  SharedInformationMyLongitude = longitude;
                  SharedInformationMyLatitude = latitude;
            
                MessageBox.Show("Your location was successfully set!");
                
           

        }

        private void ApplicationBarIconButton_Click_3(object sender, EventArgs e)
        {
           
            Pushpin p = new Pushpin();
            p.Background = new SolidColorBrush(Colors.Yellow);
            p.Foreground = new SolidColorBrush(Colors.Black);
            p.Location = new GeoCoordinate(SharedInformationMyLatitude, SharedInformationMyLongitude);
            p.Content = "I'm here";
            map1.Children.Add(p);
            map1.SetView(new GeoCoordinate(SharedInformationMyLatitude, SharedInformationMyLongitude, 200), 9);
        }

     
        

      

       

       


    }
}